#include "lolevel.h"
#include "platform.h"
#include "core.h"
#include "keyboard.h"


extern long link_bss_start;
extern long link_bss_end;
extern void boot();

void startup() {
    long *bss = &link_bss_start;
    // sanity check
    if ((long)&link_bss_end > (MEMISOSTART + MEMISOSIZE)) {
        started();
        shutdown();
    }
    // initialize .bss senment
    while (bss<&link_bss_end)
        *bss++ = 0;
    boot();
}


const int zoom_points = 1;
extern unsigned int _GetLensFocalLengthAll(unsigned int*, unsigned int*, unsigned int*);

int get_effective_focal_length(__attribute__ ((unused))int zp) {
	unsigned int focal [3];
	_GetLensFocalLengthAll(&focal[0], &focal[1], &focal[2]);
	return ( (unsigned short)(focal[0]) * 1600  ) ;
}

int get_focal_length(int zp) {
	unsigned int focal [3];
	_GetLensFocalLengthAll(&focal[0], &focal[1], &focal[2]);
    if (zp==0) return focal[1] * 1000;           // ,[1]=wide
	return ((unsigned short)(focal[0]) * 1000);	 // ,[0]=current
}
        
int get_zoom_x(__attribute__ ((unused))int zp) {
	unsigned int focal [3];
	_GetLensFocalLengthAll(&focal[0], &focal[1], &focal[2]);
//	return (unsigned short)(focal[0]) * 10 / (unsigned short)(focal[1]) ;
	return (unsigned short)(focal[0]) * 15 / (unsigned short)(focal[1]) -15;
}

long get_vbatt_min()
{
    return 2*3300;
}


long get_vbatt_max()
{
    return 2*4168;  // 4168 original battery just charged ASM1989
}
